/*****************************************************************************************************
 *
 * Dual 3.5" HDD case for Odroid H2/H2+
 *
 * Author: T.Wirtl 2020
 *
 * This work is licensed under a Creative Commons Attribution-ShareAlike 4.0 International License.
 * See http://creativecommons.org/licenses/by-sa/4.0/ for license details.
 *
 *****************************************************************************************************/

include <external/sbc_models.scad>
$fn=100;

module side_panel(vents=true)
{
    difference()
    {
        group() 
        {
            difference()
            {
                translate([-10,0,0]) cube([3,190,110]);
                translate([-10+0.61,-170/2+190/2,-90/2+110/2]) cube([2.4,170,90]);
            }
            
            
            translate([-10+0.1,-171/2+190/2,-91/2+110/2])difference()
            {
                cube([2.9,171,91]);
                

                for ( i = [0 : 1 : 10] )
                {
                    
                    translate([0,i*30,0*30]) rotate([45,0,0]) cube([20,20,20]);
                    translate([0,i*30,1*30]) rotate([45,0,0]) cube([20,20,20]);
                    translate([0,i*30,2*30]) rotate([45,0,0]) cube([20,20,20]);
                    translate([0,i*30,3*30]) rotate([45,0,0]) cube([20,20,20]);
                    
                    translate([0,i*30+15,0*30-15]) rotate([45,0,0]) cube([20,20,20]);
                    translate([0,i*30+15,1*30-15]) rotate([45,0,0]) cube([20,20,20]);
                    translate([0,i*30+15,2*30-15]) rotate([45,0,0]) cube([20,20,20]);
                    translate([0,i*30+15,3*30-15]) rotate([45,0,0]) cube([20,20,20]);
                }
            }
            
            
            translate([-10,-160/2+190/2,0]) cube([8,160,8]);
            
            translate([-10,0,-90/2+110/2]) cube([8,8,100-3]);
            translate([-10,182,-90/2+110/2]) cube([8,8,100-3]);

            translate([-10,-190/2+190/2,105]) cube([8,190,3]);
            
            if (vents)
            {
                for ( i = [0 : 10 : 60] ){ hull()
                {
                translate([-7,30+i,15]) rotate([0,-90,0]) cylinder(h=3, d=5);
                translate([-7,30+i,45]) rotate([0,-90,0]) cylinder(h=3, d=5);
                } }
            }        
            
        }
        
        if (vents)
        {
            for ( i = [0 : 10 : 60] )
            { 
                hull()
                {
                translate([-6,30+i,15]) rotate([0,-90,0]) cylinder(h=5, d=3);
                translate([-6,30+i,45]) rotate([0,-90,0]) cylinder(h=5, d=3);
                } 
            }
        }


        translate([55-60,95-70,-3.1]) cylinder(h=30, d=3.2);
        translate([55-60,95,-3.1]) cylinder(h=30, d=3.2);
        translate([55-60,95+70,-3.1]) cylinder(h=30, d=3.2);

        hull()
        {
            translate([55-60,95-70,3]) cylinder(h=2.4, d=6.4, $fn=6);
            translate([55-50,95-70,3]) cylinder(h=2.4, d=6.4, $fn=6);
        }

        hull()
        {
            translate([55-60,95,3]) cylinder(h=2.4, d=6.4, $fn=6);
            translate([55-50,95,3]) cylinder(h=2.4, d=6.4, $fn=6);
        }

        hull()
        {
            translate([55-60,95+70,3]) cylinder(h=2.4, d=6.4, $fn=6);
            translate([55-50,95+70,3]) cylinder(h=2.4, d=6.4, $fn=6);
        }
        

        translate([-5,-1,30]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([-5,-1,80]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        
        hull()
        {
            translate([-5,3,30]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3,30]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        hull()
        {
            translate([-5,3,80]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3,80]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }

        hull()
        {
            translate([-5,3+181,30]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3+181,30]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        hull()
        {
            translate([-5,3+181,80]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3+181,80]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        translate([0,-1,95]) rotate([-90,0,0]) cylinder(d=11, h=300);
        translate([0,-1,60]) rotate([-90,0,0]) cylinder(d=11, h=300);
        
    }
}

module top(vents=true)
{
    difference()
    {
        group() 
        {
            difference()
            {
                translate([-10+3,0,110-2]) cube([130-6,190,2]);
                //translate([-115/2+130/2-10,-174/2+190/2,110-3.1]) cube([115,174,2.5]);
            }
            
            translate([-116/2+130/2-10,-175/2+190/2,110-2]) difference()
            {
                cube([116,175,1.8]);
                

                for ( i = [-1 : 1 : 6] )
                {   
                    translate([0*30,i*30,-5]) rotate([0,0,45]) cube([20,20,20]);    
                    translate([1*30,i*30,-5]) rotate([0,0,45]) cube([20,20,20]);
                    translate([2*30,i*30,-5]) rotate([0,0,45]) cube([20,20,20]);
                    translate([3*30,i*30,-5]) rotate([0,0,45]) cube([20,20,20]);
                    translate([4*30,i*30,-5]) rotate([0,0,45]) cube([20,20,20]);
                    
                    translate([0*30-15,i*30+15,-5]) rotate([0,0,45]) cube([20,20,20]);
                    translate([1*30-15,i*30+15,-5]) rotate([0,0,45]) cube([20,20,20]);
                    translate([2*30-15,i*30+15,-5]) rotate([0,0,45]) cube([20,20,20]);
                    translate([3*30-15,i*30+15,-5]) rotate([0,0,45]) cube([20,20,20]);
                    translate([4*30-15,i*30+15,-5]) rotate([0,0,45]) cube([20,20,20]);
                }


            }

            translate([-100/2+130/2-10,0,102]) cube([100,8,8]);
            translate([-100/2+130/2-10,182,102]) cube([100,8,8]);

            if (vents)
            {
                for ( i = [-40 : 10 : 40] ){ 
                    hull()
                    {
                        translate([130/2-10+i,20,108]) cylinder(h=2, d=5);
                        translate([130/2-10+i,40,108]) cylinder(h=2, d=5);
                    } 
                }
            }  
        }
        
        if (vents)
        {
            for ( i = [-40 : 10 : 40] )
            {
                hull()
                {
                translate([130/2-10+i,20,105]) cylinder(h=10, d=3);
                translate([130/2-10+i,40,105]) cylinder(h=10, d=3);
                } 
            }
        }  
        
        translate([55+25,-1,105]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([55-25,-1,105]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        
        hull()
        {
            translate([55+25,3,105]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([55+25,3,90]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        hull()
        {
            translate([55-25,3,105]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([55-25,3,90]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        hull()
        {
            translate([55+25,184,105]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([55+25,184,90]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        hull()
        {
            translate([55-25,184,105]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([55-25,184,90]) rotate([-90,90,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
    } 
}

module foot()
{
    // foot
    difference()
    {
        cylinder(h=10,d=12);
        translate([0,0,-0.5])cylinder(h=11,d=3.2);
        translate([0,0,-0.01])cylinder(h=7.01,d=6);
        translate([0,0,-0.01])cylinder(h=0.21,d=11.6);
    }
}

module fan_front()
{
        // Fan front
    difference()
    {
        group()
        {
            translate([-8.8,193,-3]) cube([128-0.4,3,112 - 0.2]);
            translate([-7,182,0]) cube([124,13,8]);
        }
        
        // Fan
        translate([55,200,55]) rotate([90,0,0]) cylinder(d=82.5, h=30);
        translate([55+82.5/2,200,55+82.5/2]) rotate([90,0,0]) cylinder(d=4.5, h=30);
        translate([55+82.5/2,200,55-82.5/2]) rotate([90,0,0]) cylinder(d=4.5, h=30);
        translate([55-82.5/2,200,55+82.5/2]) rotate([90,0,0]) cylinder(d=4.5, h=30);
        translate([55-82.5/2,200,55-82.5/2]) rotate([90,0,0]) cylinder(d=4.5, h=30);
        
        // HDD Rail Mount
        translate([0,-1,95]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([0,-1,60]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([110,-1,95]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([110,-1,60]) rotate([-90,0,0]) cylinder(d=3.2, h=300);


        // Side screw holes
        translate([55+25,-1,105]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([55-25,-1,105]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        
        translate([115,-1,30]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([115,-1,80]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        
        translate([-5,-1,30]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([-5,-1,80]) rotate([-90,0,0]) cylinder(d=3.2, h=300);

        // Cable hole
        hull()
        {
            translate([20,200,4]) rotate([90,0,0]) cylinder(d=8.5, h=30);
            translate([30,200,4]) rotate([90,0,0]) cylinder(d=8.5, h=30);
        }
        
        // Screw holes
        translate([55+50,188,-3.1]) cylinder(h=30, d=3.2);
        translate([55,188,-3.1]) cylinder(h=30, d=3.2);
        translate([55-50,188,-3.1]) cylinder(h=30, d=3.2);
        
        // Nut holes
        translate([55+50,188,5]) cylinder(h=30, d=6.4, $fn=6);
        translate([55,188,5]) cylinder(h=30, d=6.4, $fn=6);
        translate([55-50,188,5]) cylinder(h=30, d=6.4, $fn=6);
    }
}

module back()
{
    // Back plate
    difference()
    {
        group()
        {
            translate([-10,0,-3]) cube([130,3,113]);
            translate([-7,0,0]) cube([124,13,8]);
        }   

        // Audio con
        translate([110-8.4-6.5,-0.1,13]) cube([13,11,36.5]);
        
        translate([110-8.4-5.5,-0.1,15]) cube([11,11,11]);
        translate([110-8.4,-0.1,31]) rotate([-90,0,0])cylinder(h=10,d=10);
        translate([110-8.4,-0.1,43]) rotate([-90,0,0])cylinder(h=10,d=10);
        
        // Display
        translate([110-32.55-10,-0.1,13]) cube([20,11,20]);
        
        // LAN USB 1
        translate([110-55.4-10,-0.1,13]) cube([20,11,33]);
        
        // LAN USB 2
        translate([110-80.17-10,-0.1,13]) cube([20,11,33]);
        
        // Power
        translate([110-103.02-5.5,-0.1,13]) cube([11,11,12]);
        
        // Vents
        for ( i = [-40 : 10 : 40] ){
            hull()
            {
                translate([55 + i,-0.1,95]) rotate([-90,0,0])cylinder(h=10,d=5);
                translate([55 + i,-0.1,60]) rotate([-90,0,0])cylinder(h=10,d=5);
            }
        }
        
        // Holes
        // HDD Rail Mount
        translate([0,-1,95]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([0,-1,60]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([110,-1,95]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([110,-1,60]) rotate([-90,0,0]) cylinder(d=3.2, h=300);


        // Side screw holes
        translate([55+25,-1,105]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([55-25,-1,105]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        
        translate([115,-1,30]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([115,-1,80]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        
        translate([-5,-1,30]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        translate([-5,-1,80]) rotate([-90,0,0]) cylinder(d=3.2, h=300);
        
        // Screw holes
        translate([55+50,8,-3.1]) cylinder(h=30, d=3.2);
        translate([55,8,-3.1]) cylinder(h=30, d=3.2);
        translate([55-50,8,-3.1]) cylinder(h=30, d=3.2);
        
        // Nut holes
        translate([55+50,8,5]) cylinder(h=30, d=6.4, $fn=6);
        translate([55,8,5]) cylinder(h=30, d=6.4, $fn=6);
        translate([55-50,8,5]) cylinder(h=30, d=6.4, $fn=6);
        
    }       
}

module bottom(maintenance=false)
{
    // Bottom
    difference()
    {
        group()
        {
            translate([-10,3,-3]) cube([130,190,3]);
            
            // Board mounts
            translate([0,3,0])
            {

                translate([3.81,17.78,-0.01]) cylinder(h=12, d=6.01);
                translate([3.81,17.78+88.41,-0.01]) cylinder(h=12, d=6.01);
                translate([110-3.96,17.78+88.41,-0.01]) cylinder(h=12, d=6.01);
                translate([110-3.96,24.77,-0.01]) cylinder(h=12, d=6.01);

                translate([3.81,17.78,-0.01]) cylinder(h=8, d=10);
                translate([3.81,17.78+88.41,-0.01]) cylinder(h=8, d=10);
                translate([110-3.96,17.78+88.41,-0.01]) cylinder(h=8, d=10);
                translate([110-3.96,24.77,-0.01]) cylinder(h=8, d=10);
            }
            
            if (maintenance)
            {
                hull()
                {
                    translate([99-5,110+5,0]) cylinder(h=2, d=4);
                    translate([99+5,110-5,0]) cylinder(h=2, d=4);
                }
                hull()
                {
                    translate([99-5,35-5,0]) cylinder(h=2, d=4);
                    translate([99+5,35+5,0]) cylinder(h=2, d=4);
                }
                hull()
                {
                    translate([6,72.5-25,0]) cylinder(h=4, d=10);
                    translate([20,72.5-25,0]) cylinder(h=4, d=10);
                }
                hull()
                {
                    translate([6,72.5+25,0]) cylinder(h=4, d=10);
                    translate([20,72.5+25,0]) cylinder(h=4, d=10);
                }
            }            
        }
        
        // bottom screwholes
        translate([55+50,8,-3.1]) cylinder(h=30, d=3.2);
        translate([55,8,-3.1]) cylinder(h=30, d=3.2);
        translate([55-50,8,-3.1]) cylinder(h=30, d=3.2);

        translate([55+60,98-70,-3.1]) cylinder(h=30, d=3.2);
        translate([55+60,98,-3.1]) cylinder(h=30, d=3.2);
        translate([55+60,98+70,-3.1]) cylinder(h=30, d=3.2);
        
        translate([55-60,98-70,-3.1]) cylinder(h=30, d=3.2);
        translate([55-60,98,-3.1]) cylinder(h=30, d=3.2);
        translate([55-60,98+70,-3.1]) cylinder(h=30, d=3.2);
        
        translate([55+50,188,-3.1]) cylinder(h=30, d=3.2);
        translate([55,188,-3.1]) cylinder(h=30, d=3.2);
        translate([55-50,188,-3.1]) cylinder(h=30, d=3.2);
        
        // Maintenance
        if (maintenance)
        {
            difference()
            {
                hull()
                {
                    translate([11,35,-10]) cylinder(h=10.01, d=3.2);
                    translate([11,110,-10]) cylinder(h=10.01, d=3.2);
                    translate([99,110,-10]) cylinder(h=10.01, d=3.2);
                    translate([99,35,-10]) cylinder(h=10.01, d=3.2);
                }
                
                
                hull()
                {
                    translate([99,110,-3]) cylinder(h=3.01, d=0.8);
                    translate([99-2,110-2,-3]) cylinder(h=3.01, d=0.8);
                }
                hull()
                {
                    translate([99,35,-3]) cylinder(h=3.01, d=0.8);
                    translate([99-2,35+2,-3]) cylinder(h=3.01, d=0.8);
                }
                
                
                
            }
            hull()
            {
                translate([55+46,72.5+25,-1.50]) cylinder(h=30, d=6);
                translate([55+46,72.5-25,-1.50]) cylinder(h=30, d=6);
            }
            difference()
            {
                hull()
                {
                    translate([6,72.5-25,-3.01]) cylinder(h=1.5, d=8);
                    translate([20,72.5-25,-3.01]) cylinder(h=1.5, d=8);                
                }
                translate([6,72.5-25,-3.01]) cylinder(h=1.5, d=4.4);
            }
            difference()
            {
                hull()
                {
                    translate([6,72.5+25,-3.01]) cylinder(h=1.5, d=8);
                    translate([20,72.5+25,-3.01]) cylinder(h=1.5, d=8);                
                }
                translate([6,72.5+25,-3.01]) cylinder(h=1.5, d=4.4);
            }
            translate([6,72.5+25,-3.01]) cylinder(h=20, d=3.2);
            translate([6,72.5-25,-3.01]) cylinder(h=20, d=3.2);   
            
            hull()
            {
                translate([6,72.5-25,0]) cylinder(h=2.4, d=6.4, $fn=6);
                translate([20,72.5-25,0]) cylinder(h=2.4, d=6.4, $fn=6);
            }
            hull()
            {
                translate([6,72.5+25,0]) cylinder(h=2.4, d=6.4, $fn=6);
                translate([20,72.5+25,0]) cylinder(h=2.4, d=6.4, $fn=6);
            }
            
            hull()
            {
                translate([11,35,-10]) cylinder(h=20, d=3.2);
                translate([11,110,-10]) cylinder(h=20, d=3.2);
                translate([30,110,-10]) cylinder(h=20, d=3.2);
                translate([30,35,-10]) cylinder(h=20, d=3.2);
            }
            
        }
        else
        {
            for(i=[-30:10:30])
            {
                hull()
                {
                translate([55+i,50,-5]) rotate([0,0,0]) cylinder(d=3, h=20);
                translate([55+i,70,-5]) rotate([0,0,0]) cylinder(d=3, h=20);
                }
            }
        }
        
         // Mount holes
        translate([0,3,0])
        {
            translate([3.81,17.78,-10]) cylinder(h=30, d=3.2);
            translate([3.81,17.78+88.41,-10]) cylinder(h=30, d=3.2);
            translate([110-3.96,17.78+88.41,-10]) cylinder(h=30, d=3.2);
            translate([110-3.96,24.77,-10]) cylinder(h=30, d=3.2);
            
            translate([3.81,17.78,-10]) cylinder(h=15, d=6.4, $fn=6);
            translate([3.81,17.78+88.41,-10]) cylinder(h=15, d=6.4, $fn=6);
            translate([110-3.96,17.78+88.41,-10]) cylinder(h=15, d=6.4, $fn=6);
            translate([110-3.96,24.77,-10]) cylinder(h=15, d=6.4, $fn=6);
        }
    }    
}

module maintenance_plate()
{
    difference()
    {
        // Maintenance
        group()
        {
            hull()
            {
                
                
                translate([11.5,35.5,-3]) cylinder(h=3, d=3.2);
                translate([11.5,109.5,-3]) cylinder(h=3, d=3.2);
                translate([98.5,109.5,-3]) cylinder(h=3, d=3.2);
                translate([98.5,35.5,-3]) cylinder(h=3, d=3.2);
            }
            
            hull()
            {
                translate([6,72.5-25,-3]) cylinder(h=1.48, d=7.5);
                translate([20,72.5-25,-3]) cylinder(h=1.48, d=7.5);
            }
            hull()
            {
                translate([6,72.5+25,-3]) cylinder(h=1.48, d=7.5);
                translate([20,72.5+25,-3]) cylinder(h=1.48, d=7.5);
            }
      
            hull()
            {
                translate([55+46,72.5+25,-1.50]) cylinder(h=1.5, d=5.5);
                translate([55+46,72.5-25,-1.50]) cylinder(h=1.5, d=5.5);
            }
        }
        
        translate([6,72.5-25,-5]) cylinder(h=10, d=3.2);
        translate([6,72.5+25,-5]) cylinder(h=10, d=3.2);
        
        hull()
        {
            
            
            translate([13,37.5,-1.5]) cylinder(h=3, d=3.2);
            translate([13,107.5,-1.5]) cylinder(h=3, d=3.2);
            translate([97,107.5,-1.5]) cylinder(h=3, d=3.2);
            translate([97,37.5,-1.5]) cylinder(h=3, d=3.2);
        }
        
        for(i=[-30:10:30])
        {
            hull()
            {
            translate([55+i,50,-5]) rotate([0,0,0]) cylinder(d=3, h=20);
            translate([55+i,70,-5]) rotate([0,0,0]) cylinder(d=3, h=20);
            }
        }
    }
}

module HDD_Rail()
{    
    // HDD Rail Mount
    difference()
    {
        group()
        {
            translate([0,193,95]) rotate([90,0,0]) cylinder(d=10, h=10);
            translate([0,193,60]) rotate([90,0,0]) cylinder(d=10, h=10);
            
            translate([0,13,95]) rotate([90,0,0]) cylinder(d=10, h=10);
            translate([0,13,60]) rotate([90,0,0]) cylinder(d=10, h=10);
            
            translate([0,3,49]) cube([4,190,51]);
        }
        
        translate([-1+5,2.99,45]) cube([5,190.02,55]);
        
        translate([0,2.99,95]) rotate([-90,0,0]) cylinder(d=3.2, h=20);
        translate([0,2.99,60]) rotate([-90,0,0]) cylinder(d=3.2, h=20);
        
        translate([0,190+3.01-20,95]) rotate([-90,0,0]) cylinder(d=3.2, h=20);
        translate([0,190+3.01-20,60]) rotate([-90,0,0]) cylinder(d=3.2, h=20);
        
        
        hull()
        {
            translate([2,167,56]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
            translate([2,60,56]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
        }
        
        hull()
        {
            translate([2,30,56]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
            translate([2,60,56]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
        }
        
        hull()
        {
            translate([2,167,86]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
            translate([2,60,86]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
        }
        
        hull()
        {
            translate([2,30,86]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
            translate([2,60,86]) rotate([0,-90,0]) cylinder(d=8.5, h=180);
        }
        
        // Nuts
        hull()
        {
            translate([0,3+5,95]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3+5,95]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
         hull()
        {
            translate([0,3+182,60]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3+182,60]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        hull()
        {
            translate([0,3+182,95]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3+182,95]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
         hull()
        {
            translate([0,3+5,60]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
            translate([5,3+5,60]) rotate([-90,0,0]) cylinder(d=6.4, h=2.4, $fn=6);
        }
        
        
        // HDD Slots
        hull()
        {
            translate([10,30+71,86]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
            translate([10,167,86]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
        }
        
        hull()
        {
            translate([10,30,86]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
            translate([10,30+65,86]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
        }
        
        hull()
        {
            translate([10,30+71,56]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
            translate([10,167,56]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
        }
        
        hull()
        {
            translate([10,30,56]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
            translate([10,30+65,56]) rotate([0,-90,0]) cylinder(d=3.2, h=180);
        }
    }
}

module front()
{
    difference() // Button mount
    {
        group()
        {
            hull()
            {
                translate([110/2+-60 + 15+6,44,104]) rotate([90,0,0]) cylinder(d=4, h=5);
                translate([110/2+-60 + 15+6,44,83]) rotate([90,0,0]) cylinder(d=4, h=5);
                translate([110/2+-60 + 15-6,44,104]) rotate([90,0,0]) cylinder(d=4, h=5);
                translate([110/2+-60 + 15-6,44,83]) rotate([90,0,0]) cylinder(d=4, h=5);
            }
            
            hull()
            {
                translate([110/2+-60 + 15+6,44,105]) rotate([90,0,0]) cylinder(d=4, h=8);
                translate([110/2+-60 + 15+6,44,108]) rotate([90,0,0]) cylinder(d=4, h=8);
                translate([110/2+-60 + 15-6,44,105]) rotate([90,0,0]) cylinder(d=4, h=8);
                translate([110/2+-60 + 15-6,44,108]) rotate([90,0,0]) cylinder(d=4, h=8);
            }
        }
        
        hull()
        {
            translate([110/2+-60 + 15+4,45,100]) rotate([90,0,0]) cylinder(d=4, h=10);
            translate([110/2+-60 + 15+4,45,85]) rotate([90,0,0]) cylinder(d=4, h=10);
            translate([110/2+-60 + 15-4,45,100]) rotate([90,0,0]) cylinder(d=4, h=10);
            translate([110/2+-60 + 15-4,45,85]) rotate([90,0,0]) cylinder(d=4, h=10);
        }
        
        hull()
        {
            translate([110/2+-60 + 15+4,39,104]) rotate([90,0,0]) cylinder(d=4, h=2);
            translate([110/2+-60 + 15+4,39,108]) rotate([90,0,0]) cylinder(d=4, h=2);
            translate([110/2+-60 + 15-4,39,104]) rotate([90,0,0]) cylinder(d=4, h=2);
            translate([110/2+-60 + 15-4,39,108]) rotate([90,0,0]) cylinder(d=4, h=2);
        }
        
        translate([110/2-64 + 15+4,50,105]) rotate([90,0,0]) cylinder(d=2, h=20);
    }
    
    difference()
    {
        group()
        {
            hull()
            {
                translate([5,30,-3]) cylinder(d=30, h=113);
                translate([5 + 130-30,30,-3]) cylinder(d=30, h=113);
                translate([-10,0,-3])cube([130,5,113]);
            }
        }
        
        
        translate([0,0,-3]) hull()
        {
            translate([5,30,-3]) cylinder(d=30-6, h=113);
            translate([5 + 130-30,30,-3]) cylinder(d=30-6, h=113);
            translate([-10+3,6,-3])cube([130-6,5,113]);
        }
        translate([-10+3+5,-1,-6])cube([120-6,8,113]);
        
        translate([-9,-0.1,-3.1])cube([130-2,3.2,113.1-1]);
        
        for(i= [-60:30:60])
        {
            if (i != -60) hull()
            {
                translate([110/2+i + 15,10,100]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i + 15,10,85]) rotate([-90,0,0]) cylinder(d=4, h=100);
            }
            else hull()
            {

                translate([110/2+i + 15+4,10,100]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i + 15+4,10,85]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i + 15-4,10,100]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i + 15-4,10,85]) rotate([-90,0,0]) cylinder(d=4, h=100);
                
                
            }
            
            hull()
            {
                translate([110/2+i + 15,10,75]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i + 15,10,35]) rotate([-90,0,0]) cylinder(d=4, h=100);
            }
            
            hull()
            {
                translate([110/2+i + 15,10,25]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i + 15,10,10]) rotate([-90,0,0]) cylinder(d=4, h=100);
            }
            
            
            
            hull()
            {

                translate([110/2+i,10,100]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i,10,70]) rotate([-90,0,0]) cylinder(d=4, h=100);
            }
            
            hull()
            {
                translate([110/2+i,10,60]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i,10,50]) rotate([-90,0,0]) cylinder(d=4, h=100);
            }
            
            hull()
            {
                translate([110/2+i,10,40]) rotate([-90,0,0]) cylinder(d=4, h=100);
                translate([110/2+i,10,10]) rotate([-90,0,0]) cylinder(d=4, h=100);
            }
        }
        
        translate([115,-1,30]) rotate([-90,0,0]) cylinder(d=3.2, h=10);
        translate([115,-1,80]) rotate([-90,0,0]) cylinder(d=3.2, h=10);
        translate([-5,-1,30]) rotate([-90,0,0]) cylinder(d=3.2, h=10);
        translate([-5,-1,80]) rotate([-90,0,0]) cylinder(d=3.2, h=10);
        
        translate([115,6,30]) rotate([-90,0,0]) cylinder(d=6, h=25);
        translate([115,6,80]) rotate([-90,0,0]) cylinder(d=6, h=25);
        translate([-5,6,30]) rotate([-90,0,0]) cylinder(d=6, h=25);
        translate([-5,6,80]) rotate([-90,0,0]) cylinder(d=6, h=25);

        translate([0,-1,95]) rotate([-90,0,0]) cylinder(d=6, h=10);
        translate([0,-1,60]) rotate([-90,0,0]) cylinder(d=6, h=10);
        translate([110,-1,95]) rotate([-90,0,0]) cylinder(d=6, h=10);
        translate([110,-1,60]) rotate([-90,0,0]) cylinder(d=6, h=10);
        
        translate([55+25,-1,105]) rotate([-90,0,0]) cylinder(d=6, h=20);
        translate([55-25,-1,105]) rotate([-90,0,0]) cylinder(d=6, h=20);
    }
}

module button_holder()
{
    difference()
    {
        group()
        {
            translate([5,31,84]) cube([10,5,18]);
            
            translate([5,3,84]) cube([3.5,30,18]);
            hull()
            {
                translate([3,3,84]) cube([3.5,3,18]);
                translate([0,3,95]) rotate([-90,0,0]) cylinder(d=6, h=3);
            }
        }
        translate([5+3.4/2,34.01,83]) cube([6.6,2,20]);
        translate([10,30,96]) rotate([-90,0,0]) cylinder(d=3.1, h=10);
        translate([0,0,95]) rotate([-90,0,0]) cylinder(d=3.2, h=10);
    }
}

module button_inlay()
{
    difference()
    {
        group()
        {
            hull()
            {
            translate([13.5,37,99.5]) rotate([-90,0,0]) cylinder(d=4, h=6);
            translate([13.5,37,85.5]) rotate([-90,0,0]) cylinder(d=4, h=6);
            translate([6.5,37,99.5]) rotate([-90,0,0]) cylinder(d=4, h=6);
            translate([6.5,37,85.5]) rotate([-90,0,0]) cylinder(d=4, h=6);
            }

            hull()
            {
            translate([13.5,37,105]) rotate([-90,0,0]) cylinder(d=4, h=1.8);
            translate([6.5,37,105]) rotate([-90,0,0]) cylinder(d=4, h=1.8);
            translate([13.5,37,99.5]) rotate([-90,0,0]) cylinder(d=4, h=1.8);
            translate([6.5,37,99.5]) rotate([-90,0,0]) cylinder(d=4, h=1.8);
            }
              
        }
       translate([10,30,105]) rotate([-90,0,0]) cylinder(d=2, h=30);
    }
}

module complete(i=0,guts=false)
{
    

    translate([-2*i,0,0])       side_panel(vents=true);
    translate([110+2*i,190,0])  rotate([0,0,180])side_panel(false);
    translate([0,0,i])          top(vents=true);
    translate([5,5,-13-i])      foot();
    translate([105,5,-13-i])    foot();
    translate([5,185,-13-i])    foot();
    translate([105,185,-13-i])  foot();
    translate([0,-3+i,0])       fan_front();
    translate([0,-3-i,0])       back();
    translate([0,-3,0])         bottom(maintenance=true);
    translate([-i,0,0])         HDD_Rail();
    translate([110+i,190,0])    rotate([0,0,180]) HDD_Rail();
    translate([0,190+3*i,0])    front();
    translate([0,0,-i])         maintenance_plate();
    translate([0,190+(1.5*i),0])button_holder();
    translate([0,190+2*i,0])    button_inlay();
    
    if(guts)
    {
        translate ([0,0,12]) sbc("h2"); // SBC Library Copyright 2016,2017,2018,2019,2020 Edward A. Kisiel - https://forum.odroid.com/viewtopic.php?f=97&t=26243
        translate([105,18,50]) rotate([0,0,90])import("external/hdd_OK_ok38_Grabcad.stl"); // By OK - GrabCAD - https://grabcad.com/library/hard-drive-3
        translate([105,18,80]) rotate([0,0,90])import("external/hdd_OK_ok38_Grabcad.stl"); // By OK - GrabCAD - https://grabcad.com/library/hard-drive-3
        translate([87,188+i*1.5,50]) rotate([0,0,0]) import("external/fan92_AT_GrabCAD.stl"); // By A T - GrabCAD - https://grabcad.com/library/92mm-case-fan-1
    }
    
}

// Overview
complete(50,true);

// Parts for printing
//translate([0,0,10]) rotate([0,-90,-90]) side_panel(true);
//translate([0,0,10]) rotate([0,-90,-90]) side_panel(false);
//translate([117,0,110]) rotate([0,180,0]) top(vents=true);
//translate([0,0,10]) rotate([0,180,0]) foot();
//translate([9,3,196]) rotate([-90,0,0]) fan_front();
//translate([10,110,0]) rotate([90,0,0]) back();
//translate([10,-3,3]) rotate([0,0,0]) bottom(maintenance=false);
//translate([10,-3,3]) rotate([0,0,0]) bottom(maintenance=true);
//translate([-49,-3,4]) rotate([0,90,0]) HDD_Rail();
//translate([120,0,110]) rotate([0,180,0]) front();
//translate([-10,-34,3]) rotate([0,0,0]) maintenance_plate();
//translate([-5,-3,-84]) rotate([0,0,0]) button_holder();
//translate([-4.5,107,-37]) rotate([90,0,0]) button_inlay();



